﻿using System;
using ELTE.Windows.ThesisGenerator.Model;

namespace ELTE.Windows.ThesisGenerator.ViewModel
{
    /// <summary>
    /// Történeti elem típusa.
    /// </summary>
    public class HistoryItem
    {
        private ThesisGeneratorModel _Model;
        private Int32 _Value;

        /// <summary>
        /// Történeti elem példányosítása.
        /// </summary>
        /// <param name="history">Modell.</param>
        /// <param name="value">Érték.</param>
        public HistoryItem(ThesisGeneratorModel model, Int32 value)
        {
            _Model = model;
            _Value = value;
        }

        /// <summary>
        /// Érték lekérdezése.
        /// </summary>
        public String Value { get { return _Value.ToString(); } }

        /// <summary>
        /// Kijelölés lekérdezése, vagy beállítása.
        /// </summary>
        public Boolean IsChecked
        {
            get { return _Model.History.Contains(_Value); }
            set
            {
                if (value && !_Model.History.Contains(_Value))
                    _Model.Take(_Value); // így jelezzük, ha valami nem választható
                if (!value && _Model.History.Contains(_Value))
                    _Model.Drop(_Value); // így jelezzük, ha valami választható
            }
        }
    }
}
